#include "ds3/bruteForceStringMatching/bruteForceStringMatching.h"

namespace ds3
{
std::size_t bruteForceStringMatching(const std::string& source,
  const std::string& sub,
  std::size_t startIndex)
{
  using std::string;

  if (sub.empty())
    return string::npos;

  typedef string::const_iterator ConstIter;

  for (ConstIter subsequenceBegin = source.begin() + startIndex;
    subsequenceBegin != source.end();
    ++subsequenceBegin)
  {
    ConstIter sourceChar = subsequenceBegin;
    ConstIter subChar = sub.begin();

    while (sourceChar != source.end() &&
      subChar != sub.end() &&
      *sourceChar == *subChar)
    {
      ++sourceChar;
      ++subChar;
    }

    if (subChar == sub.end())
      return (sourceChar - source.begin()) - sub.size();
  }

  return string::npos;
}
};

// For the book "C++ Data Structures from Scratch, Vol. 3"
// www.cppdatastructures.com
// Copyright 2021 by Robert MacGregor.  All rights reserved.